//+------------------------------------------------------------------+
//|                                            Vasily Pip Sniper.mq4 |
//|                                                            By: E |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "By: E"

//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2


extern ENUM_TIMEFRAMES     TimeFrame = 0;
extern ENUM_APPLIED_PRICE  Price     = 6;
extern ENUM_MA_METHOD      Method    = 3;
extern string estr      = "If UseUserVariables set to false, variables are automatically chosen";
extern bool   UseUserVariables = True;
extern int    FastPeriod = 21;
extern int    SlowPeriod = 144;
extern bool   Interpolate = true;
//---- parameters



int per1, per2;
//---- buffers
double up[];
double dn[];
double WorkBuffer[];
double WorkBuffer2[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
if (!UseUserVariables)
{
// for monthly
int mn_per = 12;
int mn_fast = 3;
// for weekly
int w_per = 9;
int w_fast = 3;
// for daily
int d_per = 5;
int d_fast = 3;
// for H4
int h4_per = 12;
int h4_fast = 2;
// for H1
int h1_per = 24;
int h1_fast = 8;
// for M30
int m30_per = 16;
int m30_fast = 2;
// for M15
int m15_per = 16;
int m15_fast = 4;
// for M5
int m5_per = 12;
int m5_fast = 3;
// for M1
int m1_per = 30;
int m1_fast = 10;
//----
}  
//---- 
     if (UseUserVariables)
     {
     per1=SlowPeriod;
     per2=FastPeriod;
     }
     else
     {
      switch(Period())
     {
       case 1:     per1 = m1_per;  per2 = m1_fast;  break;
       case 5:     per1 = m5_per;  per2 = m5_fast;  break;
       case 15:    per1 = m15_per; per2 = m15_fast; break;
       case 30:    per1 = m30_per; per2 = m30_fast; break;
       case 60:    per1 = h1_per;  per2 = h1_fast;  break;
       case 240:   per1 = h4_per;  per2 = h4_fast;  break;
       case 1440:  per1 = d_per;   per2 = d_fast;   break;
       case 10080: per1 = w_per;   per2 = w_fast;   break;
       case 43200: per1 = mn_per;  per2 = mn_fast;  break;
     } 
     }
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
   //
   //
   //
   //
   //
   
   IndicatorBuffers(4);
   SetIndexBuffer(0, up);
   SetIndexBuffer(1, dn); 
   SetIndexBuffer(2, WorkBuffer);
   SetIndexBuffer(3, WorkBuffer2);
   
   SetIndexDrawBegin(0, per1 + per2);
   SetIndexDrawBegin(1, per1 + per2);

   IndicatorShortName(timeFrameToString(TimeFrame)+" Vasily Pip Sniper ZL ("+(string)per1+","+(string)per2+")");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { up[0] = limit+1; return(0); }
         if (TimeFrame!=_Period)
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);               
                  up[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,Method,"",UseUserVariables,FastPeriod,SlowPeriod,0,y);
                  dn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,Method,"",UseUserVariables,FastPeriod,SlowPeriod,1,y);
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                  //
                  //
                  //
                  //
                  //
                  
                  int n,j; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                     for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
                     {
                        up[i+j] = up[i] + (up[i+n]-up[i])*j/n;
                        dn[i+j] = dn[i] + (dn[i+n]-dn[i])*j/n;
                     }
            }
            return(0);
         }            
         

   for(i = limit; i>=0; i--)
   {
       WorkBuffer[i] = iMA(NULL, TimeFrame, per1, 0, Method, Price, i);
       WorkBuffer2[i]= iMA(NULL, TimeFrame, per2, 0, Method, Price, i);
   }
   for(i = limit; i>=0; i--)
   {
       double wMA = iMAOnArray(WorkBuffer, 0, per1, 0, Method, i);
       double lMA = WorkBuffer[i] + WorkBuffer[i] - wMA;
     
       double wMA2 = iMAOnArray(WorkBuffer2, 0, per2, 0, Method, i);
       double sMA = WorkBuffer2[i] + WorkBuffer2[i] - wMA2;
       
       up[i]=sMA-lMA;
       dn[i]=lMA-sMA;
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}